// MatchVNKSTBDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MatchVNKSTB.h"
#include "MatchVNKSTBDlg.h"
#include "../../../code/vc6/alpha1/src/blepo.h"
#include "../LogTrace/Trace.h"
using namespace blepo;
#include "match_vnk.h"
#include "bnutility.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMatchVNKSTBDlg dialog

CMatchVNKSTBDlg::CMatchVNKSTBDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMatchVNKSTBDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMatchVNKSTBDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMatchVNKSTBDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMatchVNKSTBDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMatchVNKSTBDlg, CDialog)
	//{{AFX_MSG_MAP(CMatchVNKSTBDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_DOMATCH, OnDoMatch)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMatchVNKSTBDlg message handlers

BOOL CMatchVNKSTBDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMatchVNKSTBDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMatchVNKSTBDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMatchVNKSTBDlg::OnDoMatch() 
{
  CFileDialog dlg(TRUE, _T("*.pgm"), "", OFN_FILEMUSTEXIST|OFN_PATHMUSTEXIST|OFN_HIDEREADONLY,
        "image files (*.pgm) |*.pgm|",NULL);

  char title1[]= {"Open Reference Image"};
  dlg.m_ofn.lpstrTitle= title1;

  CString path_ref_img;
  if(dlg.DoModal() == IDOK)
  {
    path_ref_img = dlg.GetPathName();  // contains the selected filename
  }

  char title2[]= {"Open Warped Image"};
  dlg.m_ofn.lpstrTitle= title2;

  CString path_warp_img;
  if(dlg.DoModal() == IDOK)
  {
    path_warp_img = dlg.GetPathName(); // contains the selected filename
  }

  //TraceStart("../../output/debug_info.txt");
  CWaitCursor wait;

  Trace(path_ref_img);
  Trace("\n");
  Trace(path_warp_img);
  Trace("\n"); 

  char* path1 = path_ref_img.GetBuffer(500);
  char* path2 = path_warp_img.GetBuffer(500);
    
  clock_t start, finish;
  start = clock();

  MatchVNK obj1(path1, path2);
  obj1.IterSegment(true);
  obj1.RunTimeInfo();
  //obj1.SaveLabelImage(path_output);
  Trace("DONE\n");

  finish = clock();
  Trace("Time taken (seconds): %lf",((double)(finish - start))/CLOCKS_PER_SEC);

  char buffer1[200];
  sprintf(buffer1,"Time taken (seconds): %lf",((double)(finish - start))/CLOCKS_PER_SEC);
  AfxMessageBox(buffer1);
  
  //TraceStop();
	
}
