#include "stdafx.h"
#include "../../../code/vc6/alpha1/src/blepo.h"
#include "../LogTrace/Trace.h"
using namespace blepo;
#include "match_vnk.h"
#include "diffuse.h"
#include "bnutility.h"

inline int absval(int val)
{
  if(val < 0)
    return -val;
  else
    return val;
}

inline float calcratio(int a, int b)
{
  if(a < b)
    return ((float) a)/((float) b);
  else
    return ((float) b)/((float) a);
}


void MatchVNK::CorrHor(int disp_x, int disp_y, ImgInt& v_hor)
{
  Location p, pd;
	int w_size, w2_size;
	int x_start, x_finish;
	int v, v_sum;

	w_size = corr_size;
	w2_size = 2*w_size + 1;

	for (p.y=0; p.y<mk_height; p.y++)
	{
		pd.y = p.y + disp_y;
		if (pd.y<0 || pd.y>=mk_height)
		{
			for (p.x=0; p.x<mk_width; p.x++) v_hor(p.x, p.y) = w2_size*default_v;
			continue;
		}

		if (disp_x > 0)
		{
			x_start = 0;
			x_finish = mk_width - 1 - disp_x;
			if (x_start > x_finish) x_finish = x_start - 1;
		}
		else
		{
			x_start = 0 - disp_x;
			x_finish = mk_width - 1;
			if (x_start > x_finish) x_start = x_finish + 1;
		}
		/* now we can access L(p) and R(p+d) if x_start<=p.x<=x_finish */

		v_sum = w2_size*default_v;
		for (p.x=x_start; p.x<x_start+w_size; p.x++)
		{
			pd.x = p.x + disp_x;
			v = DataCostCorr(p, pd);
			v_sum += v;
			v_sum -= default_v;
		}
		for (; p.x<x_start+w2_size; p.x++)
		{
			pd.x = p.x + disp_x;
			v = DataCostCorr(p, pd);
      v_sum += v;
			v_sum -= default_v;
			v_hor(p.x-w_size, p.y) = v_sum;
		}
		for (; p.x<=x_finish; p.x++)
		{
			pd.x = p.x + disp_x;
			v = DataCostCorr(p, pd);
			v_sum += v;
			v = DataCostCorr(Location(p.x-w2_size, p.y, 0), Location(pd.x-w2_size, pd.y, 0));
			v_sum -= v;
			v_hor(p.x-w_size, p.y) = v_sum;
		}
		for (; p.x<=x_finish+w_size; p.x++)
		{
			pd.x = p.x + disp_x;
			v_sum += default_v;
			v = DataCostCorr(Location(p.x-w2_size, p.y, 0), Location(pd.x-w2_size, pd.y, 0));
			v_sum -= v;
			v_hor(p.x-w_size, p.y) = v_sum;
		}

		if (disp_x > 0)
		{
			v_sum = v_hor(x_finish, p.y);
			for (p.x=x_finish+1; p.x<mk_width; p.x++)
			{
				if (p.x-w_size-1>=0 && p.x-w_size-1+disp_x<mk_width)
				{
					v = DataCostCorr(Location(p.x-w_size-1, p.y, 0), Location(p.x-w_size-1+disp_x, pd.y, 0));
					v_sum -= v;
				}
				else v_sum -= default_v;
				v_sum += default_v;
				v_hor(p.x, p.y) = v_sum;
			}
		}
		else
		{
			v_sum = v_hor(x_start, p.y);
			for (p.x=x_start-1; p.x>=0; p.x--)
			{
				if (p.x+w_size+1<mk_width && p.x+w_size+1+disp_x>=0)
				{
					v = DataCostCorr(Location(p.x+w_size+1, p.y, 0), Location(p.x+w_size+1+disp_x, pd.y, 0));
					v_sum -= v;
				}
				else v_sum -= default_v;
				v_sum += default_v;
				v_hor(p.x, p.y) = v_sum;
			}
		}
	}
}

void MatchVNK::CorrFull(const ImgInt& v_hor, ImgInt& v_full)
{
	Location p;
	int w_size, w2_size;
	int v, v_sum;

	w_size = corr_size;
	w2_size = 2*w_size + 1;

	for (p.x=0; p.x<mk_width; p.x++)
	{
		v_sum = w2_size*w2_size*default_v;
		for (p.y=0; p.y<w_size; p.y++)
		{
			v = v_hor(p.x, p.y);
			v_sum += v;
			v_sum -= w2_size*default_v;
		}
		for (; p.y<w2_size; p.y++)
		{
			v = v_hor(p.x, p.y);
			v_sum += v;
			v_sum -= w2_size*default_v;
			v_full(p.x, p.y-w_size) = v_sum;
		}
		for (; p.y<mk_height; p.y++)
		{
			v = v_hor(p.x, p.y);
			v_sum += v;
			v = v_hor(p.x, p.y-w2_size);
			v_sum -= v;
			v_full(p.x, p.y-w_size) = v_sum;
		}
		for (; p.y<mk_height+w_size; p.y++)
		{
			v_sum += w2_size*default_v;
			v = v_hor(p.x, p.y-w2_size);
			v_sum -= v;
			v_full(p.x, p.y-w_size) = v_sum;
		}
	}
}

void MatchVNK::CorrelationLR(bool left_reference)
{
  int disp_x, disp_y;
	Location p, pd;
	int w_size, w2_size;
	std::vector<ImgInt> V_FULL;
	ImgInt v_hor;
	int v;

  int min_disp_x;
  int max_disp_x;
  int min_disp_y;
  int max_disp_y;

  if(left_reference == true)
  {
    min_disp_x = mvnk_disp_x_min;
    max_disp_x = mvnk_disp_x_max;
    min_disp_y = mvnk_disp_y_min;
    max_disp_y = mvnk_disp_y_max;
  }
  else
  {
    ImgFloat tmp_img, tmp_min_img, tmp_max_img;

    tmp_img = mk_ref_img;
    mk_ref_img = mk_warp_img;
    mk_warp_img = tmp_img;

    tmp_min_img = mk_ref_min_img;
    mk_ref_min_img = mk_warp_min_img;
    mk_warp_min_img = tmp_min_img;

    tmp_max_img = mk_ref_max_img;
    mk_ref_max_img = mk_warp_max_img;
    mk_warp_max_img = tmp_max_img;

    min_disp_x = -mvnk_disp_x_max;
    max_disp_x = -mvnk_disp_x_min;
    min_disp_y = -mvnk_disp_y_max;
    max_disp_y = -mvnk_disp_y_min;
  }

	w_size = corr_size;
	w2_size = 2*w_size + 1;

	if (w_size < 0)
	{
		Trace("Error in CORR: wrong parameter!\n");
		assert(0);
	}

	/* allocating memory */
  int itr = 0;
	for (disp_y=min_disp_y; disp_y<=max_disp_y; disp_y++)
	for (disp_x=min_disp_x; disp_x<=max_disp_x; disp_x++)
	{
    V_FULL.push_back(ImgInt(mk_width, mk_height));
    assert(&(V_FULL[itr]));
    itr++;
	}
	v_hor  = ImgInt(mk_width, mk_height);
  assert(&v_hor);

	/* computing correlation values */
  itr = 0;
	for (disp_y=min_disp_y; disp_y<=max_disp_y; disp_y++)
	for (disp_x=min_disp_x; disp_x<=max_disp_x; disp_x++)
	{
		/* computing v_hor */
		CorrHor(disp_x, disp_y, v_hor);

		/* computing v_full */
		CorrFull(v_hor, V_FULL[itr]);
    itr++;

  }

  int no_points = 0;
  const int disp_x_width = mvnk_disp_x_max - mvnk_disp_x_min + 1;
  const int disp_y_width = mvnk_disp_y_max - mvnk_disp_y_min + 1;

	/* finding disparity with minimum correlation value */
	for (p.y=0; p.y<mk_height; p.y++)
	for (p.x=0; p.x<mk_width; p.x++)
	{
		int itr_min, disp_x_min, disp_y_min;
    int v_min = -1;
    int* v_arr;
    
    v_arr = new int[disp_x_width*disp_y_width];
    itr = 0;    
    for (disp_y=min_disp_y; disp_y<=max_disp_y; disp_y++)
		for (disp_x=min_disp_x; disp_x<=max_disp_x; disp_x++)
		{
			v = (V_FULL[itr])(p.x, p.y);
      v_arr[itr] = v;
      itr++;
      
      if(v<0) { AfxMessageBox("v less than 0"); assert(0); }
	    if (v_min < 0 || v < v_min)
			{
				v_min = v;
  			disp_x_min = disp_x;
        disp_y_min = disp_y;
        itr_min = itr-1;
      }
    }

    int sl2, sl1, sr1, sr2;
    float dlt1, dlt2, gaml, gamr;

    if(itr_min>=2 && itr_min<(disp_x_width*disp_y_width-2))
    {
      sl2 = absval(v_arr[itr_min-2] - v_arr[itr_min-1]); 
      sl1 = absval(v_arr[itr_min-1] - v_arr[itr_min]); 
      sr1 = absval(v_arr[itr_min] - v_arr[itr_min+1]); 
      sr2 = absval(v_arr[itr_min+1] - v_arr[itr_min+2]);
      dlt1 = calcratio(sl1, sr1);
      dlt2 = calcratio(sl2, sr2);
      gaml = calcratio(v_arr[itr_min], v_arr[itr_min-1]);
      gamr = calcratio(v_arr[itr_min], v_arr[itr_min+1]);
    }
    else
    {
      dlt1 = 0.0f;
      dlt2 = 0.0f;
    } 

    if(dlt1 > beta1 && dlt2 > beta2 && v_min < alpha &&
       gaml < gamma && gamr < gamma)
    {
      mk_corr_label(p.x, p.y) = (disp_y_min - min_disp_y)*(max_disp_x - 
                            min_disp_x + 1) + (disp_x_min - min_disp_x);
      mk_corr_hard(p.x, p.y) = 1;
      no_points++;
    }
    else
    {
      mk_corr_label(p.x, p.y) = 0;
      mk_corr_hard(p.x, p.y) = 0;
    }

    #ifdef SAVE_CORR_VECTOR
      if(p.x == 100 && p.y == 100)
      {
        char path_corr_vector[200];
        sprintf(path_corr_vector,"../../output/corr_vector.txt"); 
        WriteCorrelationVector(v_arr, disp_x_width*disp_y_width, path_corr_vector);
      }
    #endif

    delete[] v_arr;
	}

  //Trace(no_points);

  if(left_reference != true)
  {
    ImgFloat tmp_img, tmp_min_img, tmp_max_img;

    tmp_img = mk_ref_img;
    mk_ref_img = mk_warp_img;
    mk_warp_img = tmp_img;

    tmp_min_img = mk_ref_min_img;
    mk_ref_min_img = mk_warp_min_img;
    mk_warp_min_img = tmp_min_img;

    tmp_max_img = mk_ref_max_img;
    mk_ref_max_img = mk_warp_max_img;
    mk_warp_max_img = tmp_max_img;
  }

}

void MatchVNK::Correlation()
{
  ImgInt label_left, hard_left;
  ImgInt label_right, hard_right;

  CorrelationLR(true);
  label_left = mk_corr_label;
  hard_left = mk_corr_hard;

  CorrelationLR(false);
  label_right = mk_corr_label;
  hard_right = mk_corr_hard;

  //Figure fig1, fig2;
  //fig1.Draw(label_left);
  //fig2.Draw(label_right);
  //AfxMessageBox("ok");

  Set(&mk_corr_label, 0);
  Set(&mk_corr_hard, 0);

  int disp_x_width = mvnk_disp_x_max - mvnk_disp_x_min + 1;
  int disp_y_width = mvnk_disp_y_max - mvnk_disp_y_min + 1;

  int no_points = 0;
  int val, x, y, xr, yr;
  for(y=(0+disp_y_width); y<=(mk_height-disp_y_width); y++)
    for(x=(0+disp_x_width); x<=(mk_width-disp_x_width); x++)
    {
      val = label_left(x,y);
      xr = x + mk_disp_x[val];
      yr = y + mk_disp_y[val];
      if((label_right(xr, yr) + val) == (disp_x_width*disp_y_width-1))
      {
        no_points++;
        mk_corr_label(x,y) = val;
        mk_corr_hard(x,y) = 1;
      }
    }
  //SeeInt(no_points);

  //ImgBinary hard_binary;
  //Convert(mk_corr_hard, &hard_binary);
  //Erode3x3(hard_binary, &hard_binary);
  //Dilate3x3(hard_binary, &hard_binary);
  //Convert(hard_binary, &mk_corr_hard);
  //ImgInt hard_filtered;
  //MedianFilterFinal(mk_corr_hard, 3, 3, &hard_filtered);
  

  ImgInt hard_diffused, hard_orig;
  std::vector<int> hard_labels;
  DiffuseRegions(mk_corr_hard, hard_area_limit, &hard_diffused, &hard_orig, &hard_labels);
  mk_corr_hard = hard_orig;

  ImgInt::Iterator ch_p, cl_p;
  for(ch_p = mk_corr_hard.Begin(), cl_p = mk_corr_label.Begin();
      ch_p != mk_corr_hard.End(); ch_p++, cl_p++)
  {
    if(*ch_p == 0)
      *cl_p = 0;     
  }

  //Figure fig1, fig2;
  //fig1.Draw(mk_corr_label);
  //fig2.Draw(mk_corr_hard);
  //AfxMessageBox("ok");

  char path_hard_points[200];
  sprintf(path_hard_points,"../../output/hard_points.pgm");
  ImgGray corr_label_gray;
  ScaleHardPoints(&corr_label_gray);
  Save(corr_label_gray, path_hard_points, "pgm");

  //Figure fig;
  //fig.Draw(corr_label_gray);
  //AfxMessageBox("ok");
  
}

int MatchVNK::DataCostCorr(Location p, Location p_disp)
{
  p_disp.t = 0;

  if(p_disp>=PS && p_disp<=PE)
  {
	  int dl, dr, d;
	  int Il, Il_min, Il_max, Ir, Ir_min, Ir_max;

	  Il     = (int) (*(mk_ref_img.Begin(p.x,p.y))); 
	  Il_min = (int) (*(mk_ref_min_img.Begin(p.x,p.y))); 
	  Il_max = (int) (*(mk_ref_max_img.Begin(p.x,p.y))); 

    Ir     = (int) (*(mk_warp_img.Begin(p_disp.x,p_disp.y)));
    Ir_min = (int) (*(mk_warp_min_img.Begin(p_disp.x,p_disp.y)));
    Ir_max = (int) (*(mk_warp_max_img.Begin(p_disp.x,p_disp.y)));

	  if      (Il < Ir_min) dl = Ir_min - Il;
	  else if (Il > Ir_max) dl = Il - Ir_max;
	  else return 0;

	  if      (Ir < Il_min) dr = Il_min - Ir;
	  else if (Ir > Il_max) dr = Ir - Il_max;
	  else return 0;

    if(dl < dr)
      d = dl;
    else
      d = dr;

	  d = d*d;
	  if (d > data_cost_limit) d = data_cost_limit;
    return ((int) d);
  }
  else
  {
    return ((int) data_cost_oob);
  }
  
}

void MatchVNK::ScaleHardPoints(ImgGray* out)
{
  out->Reset(mk_corr_label.Width(), mk_corr_label.Height());

  ImgInt::ConstIterator cl_p;
  ImgGray::Iterator out_p;
  for(cl_p = mk_corr_label.Begin(), out_p = out->Begin(); cl_p != mk_corr_label.End(); cl_p++, out_p++)
  {
    if(*cl_p == 0)
      *out_p = 255;
    else
      //*out_p = ((mk_disp_x_max-mk_disp_x_min)-(*cl_p))*hard_points_scale_factor;
      *out_p = 0;
  }
}